#!/usr/bin/python3

import os
import subprocess
import email.charset
import locale
import socket
from subprocess import (Popen,PIPE)
from email.message import Message

### EDIT THIS PART ####
from_email = "me@web.de"
to_email = "your@address.com"
###################################

# variables for testing
MAIL_BINARY = "/usr/bin/mail"
SENDMAIL_BINARY = "/usr/sbin/sendmail"
subject = "Test mail for unattended-upgrades on " + socket.getfqdn()
body = "When you read this mail, the mail delivery should also work for unattended upgrades! :)"

# function to send via /usr/bin/mail
def _send_mail_using_mailx(from_address, to_address, subject, body):
    encoded_body = body.encode(locale.getpreferredencoding(False), errors="replace")
    mail = subprocess.Popen(
        [MAIL_BINARY, "-r", from_address, "-s", subject, to_address],
        stdin=subprocess.PIPE, universal_newlines=False)
    mail.stdin.write(encoded_body)
    mail.stdin.close()
    ret = mail.wait()
    return ret

# function to send via /usr/sbin/sendmail
def _send_mail_using_sendmail(from_address, to_address, subject, body):
    msg = Message()
    msg['Subject'] = subject
    msg['From'] = from_address
    msg['To'] = to_address
    msg['Auto-Submitted'] = "auto-generated"
    charset = email.charset.Charset("utf-8")
    charset.body_encoding = email.charset.QP  # type: ignore
    msg.set_payload(body, charset)
    sendmail = subprocess.Popen(
        [SENDMAIL_BINARY, "-oi", "-t"],
        stdin=subprocess.PIPE, universal_newlines=True)
    sendmail.stdin.write(msg.as_string())
    sendmail.stdin.close()
    ret = sendmail.wait()
    return ret

# sending mail via '/usr/sbin/sendmail' or '/usr/bin/mail'
if os.path.exists(SENDMAIL_BINARY):
    print("Sending e-mail using 'sendmail'")
    ret = _send_mail_using_sendmail(from_email, to_email, subject, body)
elif os.path.exists(MAIL_BINARY):
    print("Sending e-mail using 'mail'")
    ret = _send_mail_using_mailx(from_email, to_email, subject, body)

# output
if ret == 0:
    print("E-mail successfully sent.")
else:
    print("E-mail could not be delivered.")